

extern void __asm ClearDestLine(register __a0 struct GIOData *,
								register __d0 int,
								register __d1 UBYTE,
								register __d2 UBYTE,
								register __d3 UBYTE);

extern void __asm GetDestPixel(register __a0 struct GIOData *,
							register __d0 int, register __d1 int,
							register __a1 UBYTE *, register __a2 UBYTE *, 
							register __a3 UBYTE *);

extern void __asm GetSecondPixel(register __a0 struct GIOData *,
							register __d0 int, register __d1 int,
							register __a1 UBYTE *, register __a2 UBYTE *, 
							register __a3 UBYTE *);

extern void __asm GetSecondPixelTiled(register __a0 struct GIOData *,
							register __d0 int, register __d1 int,
							register __a1 UBYTE *, register __a2 UBYTE *, 
							register __a3 UBYTE *);

extern void __asm Error(register __a0 STRPTR);

extern LONG __asm GetOkCancel(register __a0 STRPTR, register __a1 STRPTR);

extern LONG __asm GetOneOption(register __a0 STRPTR,
			register __a1 STRPTR,
			register __a2 STRPTR,
			register __a3 UBYTE *);

extern LONG __asm GetTwoOptions(register __a0 STRPTR,
			register __a1 STRPTR,
			register __a2 STRPTR,
			register __a3 UBYTE *,
			register __a5 STRPTR,
			register __d0 STRPTR,
			register __d1 UBYTE *);

extern LONG __asm GetDimensions(register __a0 STRPTR,
                        register __a1 ULONG *,
                        register __a2 ULONG *);

extern LONG __asm GetString(register __a0 STRPTR, register __a1 STRPTR,
									register __a2 STRPTR);

extern LONG __asm OpenProgress(register __a0 STRPTR,register __a1 STRPTR);

extern LONG __asm SetProgress(register __a0 STRPTR,register __d0 LONG);

extern LONG __asm CloseProgress(void);

extern LONG __asm GetOneValue(register __a0 STRPTR,
							register __a1 STRPTR,
							register __d0 LONG,
							register __d1 LONG,
							register __a2 LONG *);




extern LONG __asm GetTwoValues(register __a0 STRPTR,
											register __a1 STRPTR,
											register __d0 LONG,
											register __d1 LONG,
											register __a2 LONG *,
											register __a3 STRPTR,
											register __d2 LONG ,
											register __d3 LONG ,
											register __a5 LONG * );


extern BOOL __asm LoadIFFPalette(register __a0 STRPTR,
												register __a1 UBYTE *);

extern LONG __asm ThreeButtonReq(register __a0 STRPTR,
								register __a1 STRPTR,
								register __a2 STRPTR,
								register __a3 STRPTR,
								register __a5 STRPTR);

extern __asm UBYTE * GetLine(register __a0 struct GIOData *,
										 register __d0 ULONG);

extern __asm UBYTE * GetDestLine(register __a0 struct GIOData *,
										 register __d0 ULONG);

extern __asm UBYTE * GetTransLine(register __a0 struct GIOData *,
										 register __d0 ULONG);

extern __asm void ReleaseTransLine(register __a0 struct GIOData *,
										 register __d0 ULONG);

extern __asm void ReleaseLine(register __a0 struct GIOData *,
											register __d0 ULONG);

extern __asm void ReleaseDestLine(register __a0 struct GIOData *,
											register __d0 ULONG);

extern LONG __asm GetThreeValues(register __a0 STRPTR,
				register __a1 STRPTR,
				register __d0 LONG, register __d1 LONG,
				register __a2 LONG *,

				register __a3 STRPTR, register __d2 LONG,
				register __d3 LONG, register __a5 LONG *,

				register __d4 STRPTR, register __d5 LONG,
				register __d6 LONG, register __d7 LONG *);


extern LONG __asm GetScaleDimensions(register __a0 STRPTR,
                        register __a1 ULONG *,
                        register __a2 ULONG *);

extern LONG __asm GetListOption(
					register __a0 STRPTR,
					register __a1 STRPTR,
					register __a2 struct TagList *,
				 	register __a3 LONG *);


extern void __asm GetSrcPixel(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG,
							register __a1 UBYTE *, register __a2 UBYTE *,
							register __a3 UBYTE *);

extern void __asm GetSrcPixelAA(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG,
							register __a1 UBYTE *, register __a2 UBYTE *,
							register __a3 UBYTE *);

extern void __asm GetDestPixelAA(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG,
							register __a1 UBYTE *, register __a2 UBYTE *,
							register __a3 UBYTE *);

extern void __asm PutDestPixel(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG,
							register __d2 UBYTE, register __d3 UBYTE,
							register __d4 UBYTE);

extern void __asm InitRandom(register __d0 ULONG);
extern LONG __asm Random(register __d0 ULONG);

extern __asm LONG PatternMatch(register __a0 STRPTR,
											register __a1 STRPTR);

extern __asm LONG GetEnvVal(register __a0 STRPTR,
										register __a1 APTR,
										register __d0 LONG);

extern __asm LONG SetEnvVal(register __a0 STRPTR,
										register __a1 APTR,
										register __d0 LONG);

extern LONG __asm OneButtonReq(register __a0 STRPTR,
					register __a1 STRPTR,
					register __a2 STRPTR);

extern BOOL __asm BuildColourLookup(register __a0 UBYTE *,
													register __a1 UBYTE *,
													register __d0 LONG,
													register __d1 LONG);

extern LONG __asm GeneratePalette(register __a0 struct GIOData *,
												register __a1 UBYTE *,
												register __d0 LONG,
												register __d1 LONG,
												register __d2 LONG);

extern UBYTE __asm FindBestRegister(register __a0 UBYTE *,
													register __a1 UBYTE *,
													register __d0 LONG,
													register __d1 LONG,
													register __d2 LONG,
													register __d3 LONG);


extern LONG __asm GetListAndVal(
	register __a0 STRPTR,
	register __a1 STRPTR,
	register __a2 struct TagList *,
	register __a3 LONG *,
	register __d0 LONG,
	register __d1 LONG,
	register __d2 STRPTR,
	register __a5 LONG *);

extern LONG __asm GetListAnd2Vals(
	register __a0 STRPTR,
	register	__a1 struct PgsWgtCycle *,
	register	__a2 struct PgsWgtSlider *,
	register	__a3 struct PgsWgtSlider *
);




extern int __asm  GetListAnd2Ops(
	register __a0 STRPTR,
	register __a1 STRPTR,
	register __a2 struct TagList *,
	register __a3 LONG		*,
	register __d0 STRPTR	,
	register __d1 STRPTR	,
	register __a5 UBYTE		*variable2,
	register __d2 STRPTR	gadgettext3a,
	register __d3 STRPTR	gadgettext3b,
	register __d4 UBYTE		*variable3);


__asm void PutPaintPixel(register __a0 struct GIOData *data, register __d0 int x, register __d1 int y, register __d2 UBYTE g);

__asm UBYTE GetPaintPixel(register __a0 struct GIOData *data, register __d0 int x, register __d1 int y);

__asm void DrawPreviewImage(register __a0 struct GIOData *data, register __a1 struct RastPort *rp,
						register __a2 APTR pixarray, register __d0 int x, register __d1 int y, register __d2 int w, register __d3 int h);

__asm void FreePreviewImage(register __a0 struct GIOData *data);

__asm UBYTE *CreatePreviewImage(register __a0 struct GIOData *data,
				register __d0 ULONG x, register __d1 ULONG y, register __d2 BOOL empty);

__asm void UpdatePreviewImage(register __a0 struct GIOData *data);

__asm void RGBtoHSV(register __a0 WORD *h, register __a1 WORD *s, register __a2 WORD *v,
						  register __a3 WORD *r, register __d0 WORD *g, register __d1 WORD *b);

__asm void HSVtoRGB(register __a0 WORD *h, register __a1 WORD *s, register __a2 WORD *v,
						  register __a3 WORD *r, register __d0 WORD *g, register __d1 WORD *b);

extern UBYTE __asm GetSrcPixel8(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG);

extern UBYTE __asm GetSrcPixel8AA(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG);

extern UBYTE __asm GetDestPixel8AA(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG);

extern UBYTE __asm GetDestPixel8(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG);

extern void __asm PutDestPixel8(register __a0 struct GIOData *,
							register __d0 LONG, register __d1 LONG,
							register __d2 UBYTE);
